OpenAPI SpecificationJSON
API Reference

Generic Engine Schema

Please note that Generic Engine Schema is an internal API and can be changed without notice.

An engine schema is an object which describes what fields are available in the engine. Do not confuse engine schema with Schema

Generic engine schema

Attribute
Type
Description
id*
read-only
integer

ID of the generic engine schema.

url*
read-only
URL

URL of the generic engine schema.

content*
object
training_queues
list[URL]

List of Queues that will be used for the training. Note that queues can't have delete_after field set, otherwise a validation error is raised.

fields
list[object]

Container for fields declarations. It may contain only objects of category multivalue or datapoint.

category
"multivalue"

Category of the object.

engine_output_id
string

Unique name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"grid" | "freeform"

Type of the trained field.

description
string

Description of field attribute.

children
object

Object specifying type of children. It may contain only objects with category tuple.

category
"tuple"

Category of the object.

children
list[object]

Array specifying objects that belong to a given tuple. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"multivalue"

Category of the object.

children
object

Object specifying type of children. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

List generic engine schemas

GET api / v1 / generic_engine_schemas

Retrieve all generic engine schema objects.

Internal API Warning: Please note that Generic Engine Schema is an internal API and can be changed without notice.

GET
/api/v1/generic_engine_schemas
curl -X GET "https://example.rossum.app/api/v1/generic_engine_schemas"
{
  "pagination": {
    "next": null,
    "previous": null
  },
  "results": [
    {
      "id": 6000,
      "url": "https://example.rossum.app/api/v1/generic_engine_schemas/6000",
      "content": {
        "training_queues": [
          "https://example.rossum.app/api/v1/queues/123",
          "https://example.rossum.app/api/v1/queues/200",
          "https://example.rossum.app/api/v1/queues/321"
        ],
        "fields": [
          {
            "category": "multivalue",
            "engine_output_id": "line_items",
            "label": "Line Items",
            "trained": true,
            "type": "grid",
            "description": "Line item column types.",
            "children": {
              "category": "tuple",
              "children": [
                {
                  "category": "datapoint",
                  "engine_output_id": "document_id",
                  "label": "Document ID",
                  "trained": true,
                  "type": "string",
                  "description": "Document number",
                  "sources": [
                    {
                      "queue": "string",
                      "schema_id": "document_id"
                    }
                  ]
                }
              ]
            }
          }
        ]
      }
    }
  ]
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
pagination*
pagination
next
URL

URL for the next page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the next page — do not attempt to construct or modify the cursor value.

previous
URL

URL for the previous page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the previous page — do not attempt to construct or modify the cursor value.

results*
id*
read-only
integer

ID of the generic engine schema.

url*
read-only
URL

URL of the generic engine schema.

content*
object
training_queues
list[URL]

List of Queues that will be used for the training. Note that queues can't have delete_after field set, otherwise a validation error is raised.

fields
list[object]

Container for fields declarations. It may contain only objects of category multivalue or datapoint.

category
"multivalue"

Category of the object.

engine_output_id
string

Unique name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"grid" | "freeform"

Type of the trained field.

description
string

Description of field attribute.

children
object

Object specifying type of children. It may contain only objects with category tuple.

category
"tuple"

Category of the object.

children
list[object]

Array specifying objects that belong to a given tuple. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"multivalue"

Category of the object.

children
object

Object specifying type of children. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

Retrieve generic engine schema

GET api / v1 / generic_engine_schemas / {genericEngineSchemaID}

Get a generic engine schema object.

Internal API Warning: Please note that Generic Engine Schema is an internal API and can be changed without notice.

GET
/api/v1/generic_engine_schemas/{genericEngineSchemaID}
curl -X GET "https://example.rossum.app/api/v1/generic_engine_schemas/0"
{
  "id": 6000,
  "url": "https://example.rossum.app/api/v1/generic_engine_schemas/6000",
  "content": {
    "training_queues": [
      "https://example.rossum.app/api/v1/queues/123",
      "https://example.rossum.app/api/v1/queues/200",
      "https://example.rossum.app/api/v1/queues/321"
    ],
    "fields": [
      {
        "category": "multivalue",
        "engine_output_id": "line_items",
        "label": "Line Items",
        "trained": true,
        "type": "grid",
        "description": "Line item column types.",
        "children": {
          "category": "tuple",
          "children": [
            {
              "category": "datapoint",
              "engine_output_id": "document_id",
              "label": "Document ID",
              "trained": true,
              "type": "string",
              "description": "Document number",
              "sources": [
                {
                  "queue": "string",
                  "schema_id": "document_id"
                }
              ]
            }
          ]
        }
      }
    ]
  }
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
id*
read-only
integer

ID of the generic engine schema.

url*
read-only
URL

URL of the generic engine schema.

content*
object
training_queues
list[URL]

List of Queues that will be used for the training. Note that queues can't have delete_after field set, otherwise a validation error is raised.

fields
list[object]

Container for fields declarations. It may contain only objects of category multivalue or datapoint.

category
"multivalue"

Category of the object.

engine_output_id
string

Unique name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"grid" | "freeform"

Type of the trained field.

description
string

Description of field attribute.

children
object

Object specifying type of children. It may contain only objects with category tuple.

category
"tuple"

Category of the object.

children
list[object]

Array specifying objects that belong to a given tuple. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"multivalue"

Category of the object.

children
object

Object specifying type of children. It may contain only objects with category datapoint.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

category
"datapoint"

Category of the object.

engine_output_id
string

Name of the new extracted field in the trained Dedicated Engine.

label
string

User-friendly label for an object, shown in the user interface.

trained
read-only
boolean

Whether the field was successfully trained.

type
"number" | "string" | "date" | "enum"

Type of the trained field.

description
string

Description of field attribute.

sources
list[object]

Mapping describing the source Queues and their fields to train this field from.

queue
URL

Queue to map the field from. Only one Queue per engine output is allowed.

schema_id
string

ID of the field to map. The id must exist in the mapped Queue's schema.

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error